Appointment
The appointment entity is what Dime.Scheduler is all about. An appointment is the main deliverable of the software and represents a block in the planning board. The appointment contains the information of the appointment such as the start and end date, and it holds references to the resources that have been assigned to it.
The following entities are exposed through the API.
Appointment
Upsert appointment
Inserts or updates an appointment record. The behavior of this procedure depends on the data you pass to it:
- The appointment id is required if you want to update an existing appointment.
- Otherwise, it inserts an appointment resource record (linking a resource to the appointment) if the record does not exist.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | ✔️ | See API reference | |
| SourceType | nvarchar(10) | ✔️ | See API reference | |
| JobNo | nvarchar(50) | ✔️ | ||
| TaskNo | nvarchar(50) | ✔️ | ||
| AppointmentNo | nvarchar(max) | 0 | ||
| AppointmentId | bigint | 0 | ||
| Subject | nvarchar(max) | |||
| Body | nvarchar(max) | |||
| Start | datetime | Use ISO 8601 format: yyyy-mm-ddThh:mm | ||
| End | datetime | Use ISO 8601 format: yyyy-mm-ddThh:mm | ||
| IsAllDayEvent | bit | 0 | This field is deprecated. | |
| Category | nvarchar(100) | See API reference | ||
| TimeMarker | nvarchar(100) | See API reference | ||
| Importance | int | 0 | See API reference | |
| Locked | bit | 0 | ||
| ResourceNo | nvarchar(50) | |||
| AppointmentGuid | nvarchar(50) | |||
| ReplaceResource | bit | 0 | ||
| SentFromBackOffice | bit | 1 | ||
| BackofficeID | nvarchar(100) | |||
| BackofficeParentID | nvarchar(100) | |||
| PlanningUOM | nvarchar(20) | |||
| PlanningUOMConversion | decimal(18,6) | 0 | ||
| PlanningQty | decimal(18,6) | 0 | ||
| UseFixPlanningQty | bit | 0 | ||
| RoundToUOM | bit | 0 | ||
| IsManualAppointment | bit | 0 | See API reference |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_upsertAppointment. - Example body:
[
{
"StoredProcedureName": "mboc_upsertAppointment",
"ParameterNames": ["SourceApp", "SourceType", "JobNo", "TaskNo", "Subject", "Start", "End"],
"ParameterValues": ["BCCOMPANY1", "JOB", "JOB001", "TASK001", "Important meeting", "2024-01-01T15:00","2024-01-02T15:00"]
}
]
- See
POST /appointment,PUT /appointmentin the REST API reference. - Example body:
{
"SourceApp": "BCCOMPANY1",
"SourceType": "JOB",
"JobNo": "JOB001",
"TaskNo": "TASK001",
"AppointmentNo": "xj0rJJb3",
"Start": "2024-01-01T15:00",
"End": "2024-01-02T15:00",
"Subject": "Important meeting"
}
Delete appointment
The behavior of this procedure depends on the data you pass to it:
- If a resource number is provided, then the appointment resource record is deleted. The appointment record is also deleted if no more appointment resource records exist for the appointment.
- If the resource number is not provided, then the appointment record and all linked appointment resource records are deleted.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | ✔️ | See API reference | |
| SourceType | nvarchar(10) | ✔️ | See API reference | |
| AppointmentNo | nvarchar(max) | 0 | ||
| AppointmentId | bigint | |||
| AppointmentGuid | nvarchar(50) | |||
| ResourceNo | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_deleteAppointment. - Example body:
[
{
"StoredProcedureName": "mboc_deleteAppointment",
"ParameterNames": ["SourceApp", "SourceType", "AppointmentNo"],
"ParameterValues": ["BCCOMPANY1", "JOB", "x0rnJJ2b"]
}
]
See DELETE /appointment in the REST API reference.
Upsert appointment URI
Inserts or updates an appointment URI record.
An appointment URI contains links to documents, web pages and the back-office system. You need to pass an existing appointment id or appointment GUID.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| pSourceApp | nvarchar(30) | See API reference | ||
| pSourceType | nvarchar(10) | See API reference | ||
| pAppointmentId | bigint | 0 | ||
| pAppointmentGuid | nvarchar(50) | |||
| pUrl | nvarchar(1000) | ✔️ | ||
| pUrlDesc | nvarchar(255) |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_upsertAppointmentUrl. - Example body:
[
{
"StoredProcedureName": "mboc_upsertAppointmentUrl",
"ParameterNames": ["pUrl", "pAppointmentId"],
"ParameterValues": ["https://docs.dimescheduler.com", "15123"]
}
]
See POST /appointmentUri, PUT /appointmentUri in the REST API reference.
Upsert appointment container
Adds or updates the allocation of an appointment to a container.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| Container | nvarchar(100) | ✔️ | Name of the container | |
| Appointment | nvarchar(100) | ✔️ | Appointment GUID or AppointmentNo |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_upsertAppointmentContainer. - Example body:
[
{
"StoredProcedureName": "mboc_upsertAppointmentContainer",
"ParameterNames": ["Container", "Appointment"],
"ParameterValues": ["CONTAINER001", "200"]
}
]
- See
POST /appointmentContainer,PUT /appointmentContainerin the REST API reference. - Example body:
[
{
"container": "Container 1",
"appointment": "ad37cfba-f502-4592-883d-4b10433722fe"
},
{
"container": "Container 1",
"appointment": "ad37cfba-f502-4592-883d-4b10433722ff"
}
] - Note: The
appointmentfield accepts either an appointment GUID or AppointmentNo.
Add assignment
Add a resource to an existing appointment, thereby creating a linked appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | ✔️ | ||
| AppointmentNo | nvarchar(max) | 0 | ||
| ResourceNo | nvarchar(50) | ✔️ | ||
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_addAppointmentResource. - Example body:
[
{
"StoredProcedureName": "mboc_addAppointmentResource",
"ParameterNames": ["AppointmentId", "ResourceNo"],
"ParameterValues": ["100", "2"]
}
]
See POST /assignment, PUT /assignment in the REST API reference.
Properties
Update appointment content
Updates the body and subject of the selected appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 | ||
| Subject | nvarchar(max) | |||
| Body | nvarchar(max) |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentContent. - Example body:
[
{
"StoredProcedureName": "mboc_updateAppointmentContent",
"ParameterNames": ["AppointmentId", "Subject"],
"ParameterValues": ["1", "Hello world!"]
}
]
See POST /appointmentContent in the REST API reference.
Update appointment planning quantity
Updates the planning quantity of an appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| PlanningQty | decimal(18,6) | |||
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentPlanningQty. - Example body:
[
{
"StoredProcedureName": "mboc_updateAppointmentPlanningQty",
"ParameterNames": ["AppointmentId", "PlanningQty"],
"ParameterValues": ["1", "24"]
}
]
See POST /appointmentPlanningQuantity in the REST API reference.
Indicators
Set time marker
Update the time marker assigned to the appointment. Can be used to update status or progress of the appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| TimeMarker | nvarchar(100) | |||
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentTimeMarker. - Example body:
[
{
"StoredProcedureName": "mboc_updateAppointmentTimeMarker",
"ParameterNames": ["AppointmentId", "TimeMarker"],
"ParameterValues": ["1", "TIMEMARKER002"]
}
]
See POST /appointmentTimeMarker in the REST API reference.
Set category
Updates the category assigned to the appointment. Can be used to update status or progress of the appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| Category | nvarchar(100) | |||
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentCategory. - Example body:
[
{
"StoredProcedureName": "mboc_updateAppointmentCategory",
"ParameterNames": ["AppointmentId", "Category"],
"ParameterValues": ["1", "CATEGORY002"]
}
]
See POST /appointmentCategory in the REST API reference.
Field values
Sets the field value of an appointment
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| AppointmentGuid | nvarchar(50) | |||
| FieldCode | nvarchar(100) | 0 | ||
| FieldValue | nvarchar(MAX) | 1 | ||
| SentFromBackOffice | nvarchar(MAX) | 1 |
- Import
- API
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentFieldValues. - Example body:
[
{
"StoredProcedureName": "mboc_updateAppointmentFieldValues",
"ParameterNames": ["AppointmentId","FieldCode","FieldValue"],
"ParameterValues": ["1","FINISHED","true"]
}
]
See POST /appointmentFieldValue, PUT /appointmentFieldValue in the REST API reference.
Set importance
Sets the importance of an appointment.
| Name | Data Type | Default | Required | Description |
|---|---|---|---|---|
| SourceApp | nvarchar(30) | See API reference | ||
| SourceType | nvarchar(10) | See API reference | ||
| AppointmentId | bigint | |||
| AppointmentNo | nvarchar(max) | 0 | ||
| Importance | int | 0 | See API reference | |
| AppointmentGuid | nvarchar(50) | |||
| SentFromBackOffice | bit | 1 |
- Import
- This endpoint is available in the import API endpoint
/importvia the proceduremboc_updateAppointmentImportance. - Example body:
{
"AppointmentNo": "ZVELNXY4",
"FieldCode": "FINISHED",
"FieldValue": "true"
}
API reference
Source
Dime.Scheduler is a centralized planning application. One of its key tenets is the ability to accommodate data from different origins. For instance, it is perfectly acceptable to plan work orders from Business Central, CRM, imported Excel sheets, etc., and Dime.Scheduler won't break a sweat because of the existence of the Source App and Source Type fields in the data model.
Source App
When the planner creates an appointment for a resource or task, Dime.Scheduler knows which system to notify. Through the connector setup, Dime.Scheduler will find a matching SourceApp and subsequently send the appointment to the corresponding URI.
The source app field is a unique identifier that identifies a back-office instance such as a tenant of Business Central, a test environment, an instance of CRM cloud, or any other application you wish to use to feed data into Dime.Scheduler.
Source Type
The SourceType is used inside the back-office system itself. A source type represents a distinct entity such as a service order, production order, assembly order, etc.
The standard connectors that Dime Software provides make it possible to plan different types of resources and tasks. When Dime.Scheduler posts an appointment to a standard connector, it ends up in a staging table, which is then processed by the connector to ensure the appointment produced in Dime.Scheduler is traced back to the original record using the externally identifiable fields (JobNo, TaskNo, ResourceNo) that identify the record.
Category
Controls the visual indicator of the planned task in the planning board. Read more about this topic here.
Time Marker
Controls the visual indicator of the planned task in the planning board. Read more about this topic here.
Manual appointment
Set this flag to true to create a manual appointment. Manual appointments don't require a job and task.